;****************************************************************************************
;     Proteus      
;  .
;****************************************************************************************

             list      p=16f628a     ; 
             #include  p16f628a.inc  ;   . 
             __config  3f18h         ; MCLRE  .
                                     ; WDT  .
                                     ; PWRT .
                                     ;  RC- 4
                                     ; CP -    .
                                     ; CPD-   EEPROM .
                                     ; BOREN -     
;****************************************************************************************
;  
;****************************************************************************************
        
w_temp       equ       70h
stat_temp    equ       71h
;-------------------------------------------------------------
flag         equ       72h           ;  .
;-------------------------------------------------------------
RB4          equ       0             ;    RB4
RB5          equ       1
RB6          equ       3
RB7          equ       4
           
;****************************
;   . 
;****************************                                   
             org        0
             goto      start
;****************************
;    .
;****************************
             org        4
;****************************
;  
;****************************
;    STATUS  W  .
;----------------------------------------------------
int          movwf     w_temp        ; W -> w_temp 
             movf      STATUS,W      ; STATUS -> W
             movwf     stat_temp     ; W -> stat_temp
             bcf       STATUS,RP0    ;  0   . 
;---------------------------------------------------------------------
;      RB0,    .
;---------------------------------------------------------------------
RB4_RB7      movf      PORTB,F       ;     
             bcf       INTCON,RBIF   ;  .     RB0..RB4. 
             btfss     flag,RB4
             goto      on_RB4        ; 
             goto      off_RB4       ;             
on_RB4       bsf       PORTB,0       ;  "1"  RB4.
             bsf       flag,RB4
             goto      end_int                                           
off_RB4      bcf       PORTB,0       ;  "0"  RB4.
             bcf       flag,RB4     
             goto      end_int       
;-------------------------------------------------------------------
;          .
;-------------------------------------------------------------------
end_int                 
             bcf       INTCON,T0IF   ;  .   TMR0
             bcf       INTCON,INTF   ;  .   int (INTF=0)
             movf      stat_temp,W   ; 
             movwf     STATUS        ; 
             swapf     w_temp,F
             swapf     w_temp,W
             retfie                  ;   
;*****************************************************************************************

;---------------------------------------------------------------------------------------------
;  .
;---------------------------------------------------------------------------------------------
start        movlw     .7
             movwf     CMCON
;*********************************************************************************************
; 
;*********************************************************************************************
             clrf      INTCON
             clrf      PORTA         ;     .
             clrf      PORTB         ;     .
             bsf       STATUS,RP0    ; 1- . 
             movlw     b'11111110'   
             movwf     TRISB         ;   .
             movlw     b'10000000'   ; 
             movwf     OPTION_REG    ;    CLKOUT
                                     ;    (7-  =1)
             bcf       STATUS,RP0  
             bsf       INTCON,GIE

             bsf       INTCON,PEIE   ;     .
;*********************
;**  RB4..RB7 ***
;***********************
             bsf       INTCON,RBIE   ;     .   
                                     ;   RB4..RB7.
             nop
             goto      $-1

;*********************************************************************************************
             end                             
;DataSectionPreferencesPicAsmEditor
;CursorPosition = 2212
;Folding = 
;PIC = PIC16F628A